"use client";
import { u as useEditorSearch } from "../../search-BQZJ_KqM.js";
import { u, c, b, a } from "../../selection-DjHI49dA.js";
import { useLayoutEffect } from "react";
import { u as useStableRef } from "../../core-BNmBiIXk.js";
const useShowInvisibles = (editor, alwaysShow) => {
  const show = useStableRef([alwaysShow]);
  const searchAPI = useEditorSearch(editor, "pce-invisibles");
  show[0] = alwaysShow;
  useLayoutEffect(() => {
    let prev;
    const matches = searchAPI.matches;
    const container = searchAPI.container;
    const nodes = container.children;
    const tabs = [];
    const update = () => {
      const value = editor.value;
      const [start, end] = editor.getSelection();
      if (!show[0] || prev != (prev = value)) {
        searchAPI.search(" |	", true, false, true, show[0] ? void 0 : [start, end]);
        for (let i = 0, l = matches.length; i < l; i++) {
          if (value[matches[i][0]] == "	" == !tabs[i]) {
            nodes[i].className = (tabs[i] = !tabs[i]) ? "pce-tab" : "";
          }
        }
      }
    };
    if (editor.value) update();
    return editor.on("selectionChange", update);
  }, []);
};
export {
  u as useEditorReplace,
  useEditorSearch,
  c as useHighlightCurrentWord,
  b as useHighlightSelectionMatches,
  a as useSearchWidget,
  useShowInvisibles
};
//# sourceMappingURL=index.js.map
